//////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                	//
//      Titel:		Counter sekundenweise. Variablen: Sekunde, Minute, Stunde;						//
//		Kommentar:	TIMER1 (16Bit);    CTC - Modus;            				   						//
//																		          		           	//
//   	Datum:	29.06.2010																			//
//			                                                                                        //
//////////////////////////////////////////////////////////////////////////////////////////////////////

#include <avr/io.h>
#include <avr/interrupt.h>

//globale variablen
volatile uint8_t sekunde=0;
volatile uint8_t minute=0;
volatile uint8_t stunde=0;

// prototyps
void timer1_init();
void uhrzeit();

    
int main(){

	DDRB=0xFF;  	//Am PORTB werden Sekunden angezeigt
    PORTB=0xFF;
	
	DDRD=0xFF;  	//Am PORTD werden Minuten angezeigt
    PORTD=0xFF;

	DDRA=0xFF;  	//Am PORTA werden Stunden angezeigt
    PORTA=0xFF;

    timer1_init();
   
    while(1){
    }
}

 
void timer1_init(){

    uint16_t compare_value = 31249;     /*    
                                        //  bei 8MHz fuer 1sek. compare_value = 31249; 
                                            und Prescaler 256     TCCR1B |= (1<<WGM12) | (1<<CS12);
                                        //  bei 8MHz fuer 2sek. compare_value = 15642; 
                                            und Prescaler 1024     TCCR1B |= (1<<WGM12) | (1<<CS12) | (1<<CS10);
										*/    
    // Timer 1 konfigurieren
    TCCR1A =  0;
    TCCR1B =  0;
    //TCCR1A |= (0<<COM1A1) | (1<<COM1A0);             // PIND5 aktiv, toggeln; (PWM ist aus)
    TCCR1B |= (1<<WGM12) | (1<<CS12);			     // CTC-Mode | Prescaler 256 
  
    TCNT1H=0;                                        /* Timer1-Datenregister */
    TCNT1L=0;                                        /* zuruecksetzen */
    
    TIMSK |= (1<<OCIE1A);                            // Compare Interrupt erlauben
    OCR1A = compare_value;                           // Compare-Wert: 16-Bit gross
   
    sei();                                           // Global Interrupts aktivieren

}
    
ISR(TIMER1_COMPA_vect){
    uhrzeit();
	PORTB = ~sekunde;
	PORTD = ~minute;
	PORTA = ~stunde;
}

void uhrzeit(){

	if(sekunde<60){
		sekunde ++;
		
	}else{
		sekunde=0;
		if(minute<60){
			minute++;
		}else{
			minute=0;
			if (stunde<24){
				stunde ++;
			}else{
				stunde=0;
			}
		}
	}
}

